using System;
using Microsoft.SPOT;

namespace Gadgeteer.Modules.Community.XBee
{
    /// <summary>
    /// For typed data messages, this represents the type of data
    /// When a typed message is received, an event will be called depending on the event type,
    /// e.g. for string type, the XBeeClient's StringReceived event will fire
    /// </summary>
    public enum MessageDataTypeEnum : ushort
    {
        /// <summary>
        /// A String
        /// </summary>
        String = 0x00,
        /// <summary>
        /// A Picture (TODO, describe the format, is this just a byte array? what supported formats?)
        /// </summary>
        Picture = 0x01, 
        /// <summary>
        /// a byte array
        /// </summary>
        Data = 0x02,
        /// <summary>
        /// Not Defined
        /// </summary>
        Undefined = 0x03
    }
}
