using System;
using System.Collections;
using Microsoft.SPOT;

namespace Gadgeteer.Modules.Community.XBee
{
    /// <summary>
    /// TestContext is passed to all tests through the Arrange, Act, and Assert
    /// if your test collects data that further tests need, stash it in the test context
    /// e.g. a test issues a NodeDiscovery command, stashes the discovered nodes in the TestContext Peers
    /// and an UploadStringAsync test later on uses it.
    /// Also store test settings in the TestContext Properties property
    /// </summary>
    public class TestContext
    {
        /// <summary>
        /// Initializes members
        /// </summary>
        public TestContext()
        {
            Properties = new Hashtable();
        }

        /// <summary>
        /// Hashtable of test properties
        /// </summary>
        public Hashtable Properties { get; set; }

        /// <summary>
        /// The XBee you are testing
        /// </summary>
        public XBeeClient XBee { get; set; }

        /// <summary>
        /// Array of NodeDescription, set this after issuing a ND command
        /// </summary>
        public NodeDescription[] Peers { get; set; }
    }
}
