using System;
using Microsoft.SPOT;
using System.Collections;

namespace Gadgeteer.Modules.Community.XBee
{
    /// <summary>
    /// sends a short broadcast message
    /// </summary>
    public class ShortBroadcastStringTest : BaseUploadStringAsyncTest
    {
        /// <summary>
        /// creates test and sets base class properties
        /// </summary>
        public ShortBroadcastStringTest()
            : base("hello world", 1, true)
        {

        }
    }

    /// <summary>
    /// sends a short message
    /// </summary>
    public class ShortStringTest : BaseUploadStringAsyncTest
    {
        /// <summary>
        /// creates test and sets base class properties
        /// </summary>
        public ShortStringTest()
            : base("hello world", 1, false)
        {

        }
    }

    /// <summary>
    /// sends a medium broadcast message
    /// </summary>
    public class MediumBroadcastStringTest : BaseUploadStringAsyncTest
    {
        
        /// <summary>
        /// creates test and sets base class properties
        /// </summary>
        public MediumBroadcastStringTest()
            : base("Lorem ipsum dolor sit amet, consectetur adipiscing elit. Pellentesque luctus dapibus tortor, quis interdum leo condimentum non. Quisque bibendum sodales volutpat. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi tempus auctor ornare. Vestibulum nec eros ac risus varius tincidunt. Ut sed magna turpis. Aliquam commodo mi id nisi molestie in bibendum erat dignissim. Donec quis ipsum elit. Curabitur et justo ac nibh bibendum cursus sit amet ac quam. Quisque sit amet rutrum est. In nec blandit tortor. Ut tempor justo sit amet nisl consectetur viverra. Sed vel arcu a est elementum bibendum et eget mauris. Nunc congue sollicitudin sem.",
                    9, true)
        {
            this.TimeoutMilliseconds = 20000;
        }
    }

    /// <summary>
    /// sends a medium message
    /// </summary>
    public class MediumStringTest : BaseUploadStringAsyncTest
    {
        /// <summary>
        /// creates test and sets base class properties
        /// </summary>
        public MediumStringTest()
            : base("Lorem ipsum dolor sit amet, consectetur adipiscing elit. Pellentesque luctus dapibus tortor, quis interdum leo condimentum non. Quisque bibendum sodales volutpat. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi tempus auctor ornare. Vestibulum nec eros ac risus varius tincidunt. Ut sed magna turpis. Aliquam commodo mi id nisi molestie in bibendum erat dignissim. Donec quis ipsum elit. Curabitur et justo ac nibh bibendum cursus sit amet ac quam. Quisque sit amet rutrum est. In nec blandit tortor. Ut tempor justo sit amet nisl consectetur viverra. Sed vel arcu a est elementum bibendum et eget mauris. Nunc congue sollicitudin sem.",
                    9, false)
        {
            this.TimeoutMilliseconds = 20000;
        }
    }

    /// <summary>
    /// sends a large message
    /// </summary>
    public class LargeStringTest : BaseUploadStringAsyncTest
    {
        /// <summary>
        /// creates test and sets base class properties
        /// </summary>
        public LargeStringTest()
            : base("Lorem ipsum dolor sit amet, consectetur adipiscing elit. Phasellus eu pulvinar dui. Nullam vehicula dapibus metus vel scelerisque. Suspendisse venenatis purus sed arcu tincidunt sollicitudin. Nulla non dolor ut dolor accumsan varius eu ac enim. Integer quis lacus magna. Phasellus nec feugiat arcu. Curabitur vitae elit et libero aliquam tempor at in lectus. Vivamus eleifend, mauris vitae porttitor eleifend, urna nisi luctus tellus, aliquam faucibus ante magna eu lorem. Aenean et eros sed tellus laoreet imperdiet. Pellentesque tristique ligula vel massa molestie ac lobortis ante molestie. Duis sit amet ante justo, at adipiscing elit. Nunc vestibulum, erat at interdum interdum, nisl ante vestibulum lectus, quis ultricies elit sem ac mauris. Aliquam ultrices pretium tortor pretium aliquam. Duis massa urna, facilisis eget commodo sed, tempor in magna. Vivamus fringilla, arcu quis faucibus dignissim, turpis leo molestie tortor, ac mattis magna tellus at lacus. Donec iaculis tellus neque, ac iaculis massa. Morbi vitae augue ligula, ut adipiscing nisi. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Suspendisse non dapibus orci. Proin tempor rhoncus gravida. Duis vel orci nulla. Vestibulum mattis congue orci, et egestas felis tempus nec. Duis rhoncus neque quis nisl dignissim nec aliquet turpis cursus. Vivamus suscipit elit non sem pharetra sed bibendum diam rhoncus. Fusce molestie nulla sit amet elit tristique auctor. Nam vitae orci ac diam rutrum varius quis vel elit. In eu nisl nec lorem molestie mattis. Suspendisse ullamcorper neque quis ligula cursus in semper tellus congue. Aenean mauris velit, elementum eu faucibus ac, accumsan eget ante. Mauris gravida ultrices nisi, a sagittis dui euismod vitae. Mauris ut ornare nulla. Fusce condimentum ullamcorper dolor, sit amet gravida nulla dapibus eget. Duis sed sollicitudin erat. Praesent nec nunc velit, in sollicitudin mauris. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Ut ligula urna, sollicitudin at ultricies at, eleifend ac est. Morbi porttitor lectus at felis consequat sed eleifend purus sodales. Nulla ac dui dui, sit amet pretium magna. Integer in justo metus, in cursus lacus. Nulla purus erat, dapibus ut varius ut, ullamcorper eget diam. Cras hendrerit quam vel tellus bibendum accumsan. Fusce eu justo ut risus suscipit malesuada id et neque. In neque purus, venenatis laoreet consectetur non, convallis id lorem. Sed bibendum risus et nisl porttitor sit amet facilisis purus eleifend. Praesent vel posuere lacus. Integer ac nulla est, sit amet hendrerit nisi. Cras porttitor pulvinar dignissim. Donec eu pretium nunc. Sed eget erat metus. Pellentesque nec ullamcorper risus. Nunc rutrum sodales lacus vitae aliquam. Sed consequat enim vitae libero mattis eu pulvinar dui molestie. Mauris vitae feugiat erat. Sed lobortis justo velit, sed condimentum odio. Integer euismod dignissim pellentesque. Etiam ipsum tellus, faucibus sed pharetra quis, porttitor ut massa. Sed id tincidunt felis. Curabitur augue quam, elementum id tincidunt et, ullamcorper ac elit. Phasellus ut diam enim. Mauris egestas quam vitae est ullamcorper molestie. Curabitur massa mi, pretium in fringilla quis, accumsan condimentum nisl. Phasellus fermentum elementum tincidunt. Donec tincidunt, dolor sed pretium pellentesque, sem nibh.",
                    44, false)
        {
            this.TimeoutMilliseconds = 120000;
        }
    }

    /// <summary>
    /// sends a large broadcast message
    /// </summary>
    public class LargeBroadcastStringTest : BaseUploadStringAsyncTest
    {
        /// <summary>
        /// creates test and sets base class properties
        /// </summary>
        public LargeBroadcastStringTest()
            : base("Lorem ipsum dolor sit amet, consectetur adipiscing elit. Phasellus eu pulvinar dui. Nullam vehicula dapibus metus vel scelerisque. Suspendisse venenatis purus sed arcu tincidunt sollicitudin. Nulla non dolor ut dolor accumsan varius eu ac enim. Integer quis lacus magna. Phasellus nec feugiat arcu. Curabitur vitae elit et libero aliquam tempor at in lectus. Vivamus eleifend, mauris vitae porttitor eleifend, urna nisi luctus tellus, aliquam faucibus ante magna eu lorem. Aenean et eros sed tellus laoreet imperdiet. Pellentesque tristique ligula vel massa molestie ac lobortis ante molestie. Duis sit amet ante justo, at adipiscing elit. Nunc vestibulum, erat at interdum interdum, nisl ante vestibulum lectus, quis ultricies elit sem ac mauris. Aliquam ultrices pretium tortor pretium aliquam. Duis massa urna, facilisis eget commodo sed, tempor in magna. Vivamus fringilla, arcu quis faucibus dignissim, turpis leo molestie tortor, ac mattis magna tellus at lacus. Donec iaculis tellus neque, ac iaculis massa. Morbi vitae augue ligula, ut adipiscing nisi. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Suspendisse non dapibus orci. Proin tempor rhoncus gravida. Duis vel orci nulla. Vestibulum mattis congue orci, et egestas felis tempus nec. Duis rhoncus neque quis nisl dignissim nec aliquet turpis cursus. Vivamus suscipit elit non sem pharetra sed bibendum diam rhoncus. Fusce molestie nulla sit amet elit tristique auctor. Nam vitae orci ac diam rutrum varius quis vel elit. In eu nisl nec lorem molestie mattis. Suspendisse ullamcorper neque quis ligula cursus in semper tellus congue. Aenean mauris velit, elementum eu faucibus ac, accumsan eget ante. Mauris gravida ultrices nisi, a sagittis dui euismod vitae. Mauris ut ornare nulla. Fusce condimentum ullamcorper dolor, sit amet gravida nulla dapibus eget. Duis sed sollicitudin erat. Praesent nec nunc velit, in sollicitudin mauris. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Ut ligula urna, sollicitudin at ultricies at, eleifend ac est. Morbi porttitor lectus at felis consequat sed eleifend purus sodales. Nulla ac dui dui, sit amet pretium magna. Integer in justo metus, in cursus lacus. Nulla purus erat, dapibus ut varius ut, ullamcorper eget diam. Cras hendrerit quam vel tellus bibendum accumsan. Fusce eu justo ut risus suscipit malesuada id et neque. In neque purus, venenatis laoreet consectetur non, convallis id lorem. Sed bibendum risus et nisl porttitor sit amet facilisis purus eleifend. Praesent vel posuere lacus. Integer ac nulla est, sit amet hendrerit nisi. Cras porttitor pulvinar dignissim. Donec eu pretium nunc. Sed eget erat metus. Pellentesque nec ullamcorper risus. Nunc rutrum sodales lacus vitae aliquam. Sed consequat enim vitae libero mattis eu pulvinar dui molestie. Mauris vitae feugiat erat. Sed lobortis justo velit, sed condimentum odio. Integer euismod dignissim pellentesque. Etiam ipsum tellus, faucibus sed pharetra quis, porttitor ut massa. Sed id tincidunt felis. Curabitur augue quam, elementum id tincidunt et, ullamcorper ac elit. Phasellus ut diam enim. Mauris egestas quam vitae est ullamcorper molestie. Curabitur massa mi, pretium in fringilla quis, accumsan condimentum nisl. Phasellus fermentum elementum tincidunt. Donec tincidunt, dolor sed pretium pellentesque, sem nibh.", 
                    44, true)
        {
            this.TimeoutMilliseconds = 120000;
        }
    }

    /// <summary>
    /// Issues UploadStringAsync for each Peer node
    /// </summary>
    public abstract class BaseUploadStringAsyncTest : BaseTest
    {
        ArrayList eventArgs;

        /// <summary>
        /// constructor to be called by all derived class constructors
        /// </summary>
        /// <param name="stringToSend">test string</param>
        /// <param name="numExpectedPackets">number of packets expected</param>
        /// <param name="isBroadcast">broadcast?</param>
        protected BaseUploadStringAsyncTest(string stringToSend, int numExpectedPackets, bool isBroadcast)
        {
            this.StringToSend = stringToSend;
            this.NumExpectedPackets = numExpectedPackets;
            this.IsBroadast = isBroadcast;
        }

        /// <summary>
        /// The string the derived test will send
        /// </summary>
        public string StringToSend { get;set;}

        /// <summary>
        /// Number of packets that should be created
        /// </summary>
        public int NumExpectedPackets { get;set;}

        /// <summary>
        /// Is this a broadcast message or should it be sent to individual nodes
        /// </summary>
        public bool IsBroadast { get; set; }

        /// <summary>
        /// Wire UploadStringCompleted handler
        /// </summary>
        /// <param name="context">TestContext</param>
        public override void Arrange(TestContext context)
        {
            context.XBee.TransmitStatusReceived += new TransmitStatusReceivedEventHandler(XBee_TransmitStatusReceived);
            eventArgs = new ArrayList();
        }

        void XBee_TransmitStatusReceived(object sender, TransmitStatusReceivedEventArgs e)
        {
            eventArgs.Add(e);
        }

        /// <summary>
        /// Issues UploadStringAsync for each Peer
        /// </summary>
        /// <param name="context">TestContext</param>
        public override void Act(TestContext context)
        {
            if (IsBroadast)
            {
                context.XBee.UploadStringAsync(StringToSend);
            }
            else
            {
                for (int i = 0; i < context.Peers.Length; i++)
                {
                    context.XBee.UploadStringAsync(context.Peers[i], StringToSend);
                }
            }
        }

        /// <summary>
        /// Validate that event handler called N times for N peers, and that the Error is null
        /// </summary>
        /// <param name="context">TestContext</param>
        public override void Assert(TestContext context)
        {
            int totalExpectedPackets = IsBroadast ? NumExpectedPackets : context.Peers.Length * NumExpectedPackets;

            int numReceivedOkPackets = 0;
            foreach (TransmitStatusReceivedEventArgs args in this.eventArgs)
            {
                if (args.Result.DeliveryStatus == 0x00)
                {
                    numReceivedOkPackets++;
                }
            }

            if (numReceivedOkPackets != totalExpectedPackets)
            {
                throw new XBeeAssertFailed("UploadStringCompleted event handler only called " + numReceivedOkPackets + " times with DeliveryStatus OK, should have been called " + totalExpectedPackets + " times");
            }

            foreach (TransmitStatusReceivedEventArgs args in this.eventArgs)
            {
                if (args.Error != null)
                {
                    throw new XBeeAssertFailed(args.Error.ToString());
                }
                else if (args.Result.DeliveryStatus != 0x00)
                {
                    throw new XBeeAssertFailed("Deliver status was " + HexUtil.ToHexString((byte)args.Result.DeliveryStatus) + " but should be 0x00 (OK)");
                }

            }
        }

        /// <summary>
        /// unwire the event handler
        /// </summary>
        /// <param name="context">TestContext</param>
        public override void Teardown(TestContext context)
        {
            context.XBee.TransmitStatusReceived -= XBee_TransmitStatusReceived;
        }
    }
}
